<template>
  <div class="rui-breadcrumbs">
    <template v-for="(chunk, index) in chunks" :key="index">
      <router-link v-if="chunk.to" :to="chunk.to" class="rui-breadcrumb-chunk">{{ chunk.name }}</router-link>
      <span v-else class="rui-breadcrumb-chunk">{{ chunk.name }}</span>

      <rui-icon v-if="index !== lastEntryIndex" name="rui:caret-right" />
    </template>
  </div>
</template>

<script>
import RuiIcon from '../../Icon/Icon.vue'

/**
 * Breadcrumbs from a list of entries.
 *
 * Entries must be objects with, at least, a `name` property. The optional `to` property is used for router-links.
 *
 * @preset Default { "props": { "chunks": [
 *                   { "name": "Home", "to": "#" },
 *                   { "name": "Posts", "to": "#" },
 *                   { "name": "My first post" }
 *                 ] } }
 */
export default {
  name: 'RuiBreadcrumbs',
  components: { RuiIcon },

  props: {
    /**
     * An array of objects like
     *
     * ```js
     * chunks = [
     * { name: 'Home'},
     * { name: 'Category 1', to: { name: 'categories', params: { id: 1 } } },
     * ]
     * ```
     */
    chunks: { required: true, type: Array },
  },
  computed: {
    lastEntryIndex () { return Object.keys(this.$props.chunks).length - 1 },
  },
}
</script>
